Ext.onReady(function(){

	var sin = [], cos = [];
	for (var i = 0; i < 14; i += 0.5) {
		sin.push([i, Math.sin(i)]);
		cos.push([i, Math.cos(i)]);
	}

	var panel = new Ext.FlotPanel({
		title:'Interacting with the data',
		collapsible:true,
		width:650,
		height:250,
		data:[{
			data: sin, label: "sin(x)"
		},{
			data: cos, label: "cos(x)"
		}],
		options:{
			lines: { show: true },
			points: { show: true },
			selection: { mode: "xy" },
			grid: { hoverable: true, clickable: true },
			yaxis: { min: -1.2, max: 1.2 }
		},
		renderTo: 'flot10'	
	});	
	
	panel.on('plotclick', function (event, pos, item) {
		if(item){
			alert("You clicked point " + item.dataIndex + " in " + item.series.label + ".");
			panel.highlight(item.series, item.datapoint);
		}
	});

	panel.on('plothover', function (event, pos, item) {
		$("#x").text(pos.x.toFixed(2));
		$("#y").text(pos.y.toFixed(2));

		if (item) {
			$("#tooltip").remove();
			var x = item.datapoint[0].toFixed(2);
			var y = item.datapoint[1].toFixed(2);
			showTooltip(item.pageX, item.pageY, item.series.label + " of " + x + " = " + y);
		} else {
			$("#tooltip").remove();
		}
	});
	
	function showTooltip(x, y, contents) {
		$('<div id="tooltip">' + contents + '</div>').css( {
			position: 'absolute',
			display: 'none',
			top: y + 5,
			left: x + 5,
			border: '1px solid #fdd',
			padding: '2px',
			'background-color': '#fee',
			opacity: 0.80
		}).appendTo("body").fadeIn(500);
	}

});
