Ext.onReady(function(){

	// setup plot
	function getData(x1, x2) {
		var d = [];
		for (var i = x1; i < x2; i += (x2 - x1) / 100)
			d.push([i, Math.sin(i * Math.sin(i))]);

		return [
			{ label: "sin(x sin(x))", data: d }
		];
	}

	var options = {
		legend: { show: false },
		lines: { show: true },
		points: { show: true },
		yaxis: { ticks: 10 },
		selection: { mode: "xy" }
	};

	var startData = getData(0, 3 * Math.PI);

	var mainview = new Ext.FlotPanel({
		width:650,
		height:230,
		border:false
	});	

	var overview = new Ext.FlotPanel({
		width:200,
		height:120,
		border:false
	});
	
	var panel = new Ext.Panel({
		title:'zooming with overview',
		collapsible:true,
		width:650,
		height:400,
		items:[
			mainview,
			overview
		],
		renderTo: 'flot6'
	});
	
	// mainview
	
	mainview.plot(startData, options);	

	mainview.on('plotselected', function(event, ranges){
		// clamp the zooming to prevent eternal zoom
		if (ranges.xaxis.to - ranges.xaxis.from < 0.00001)
			ranges.xaxis.to = ranges.xaxis.from + 0.00001;
		if (ranges.yaxis.to - ranges.yaxis.from < 0.00001)
			ranges.yaxis.to = ranges.yaxis.from + 0.00001;

		// do the zooming
		mainview.plot(getData(ranges.xaxis.from, ranges.xaxis.to),
			$.extend(true, {}, options, {
				xaxis: { min: ranges.xaxis.from, max: ranges.xaxis.to },
				yaxis: { min: ranges.yaxis.from, max: ranges.yaxis.to }
			}));
		
		// don't fire event on the overview to prevent eternal loop
		overview.setSelection(ranges, true);
	});

	// overview
	
	overview.plot(startData, {
		legend: { show: false },
		lines: { show: true, lineWidth: 1 },
		shadowSize: 0,
		xaxis: { ticks: 4 },
		yaxis: { ticks: 3, min: -2, max: 2 },
		grid: { color: "#999" },
		selection: { mode: "xy" }
	});
	
	overview.on('plotselected', function(event, ranges){
		mainview.setSelection(ranges);
	});

});
